Subject: Re: bug#40406: python-matplotlib fails to build on i686-linux
From: Maxim Cournoyer <[email-masked]>
To: Diego Nicola Barbato <[email-masked]>
Cc: [email-masked], Leo Famulari <[email-masked]>
Date: Sat, 14 Nov 2020 22:14:08 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello Diego,

Diego Nicola Barbato <[email-masked]> writes:

> Hey,
>
> Diego Nicola Barbato <[email-masked]> writes:
>
> [...]
>
>> Apparently there is nothing wrong with the slider.  Instead matrix
>> multiplication, which is used under the hood for transformations, seems
>> to sometimes produce incorrect results on i686-linux.  I have reported
>> this as a separate bug (https://debbugs.gnu.org/41665).
>
> I got this wrong: This issue isn't caused by the Numpy bug, since
> Matplotlib doesn't use Numpy for transformations.  Both bugs are caused
> by the excess precision of the x87 FPU's floating point registers.
>
> I've attached a patch which makes sure that the C and C++ extensions are
> compiled with -ffloat-store.  This doesn't get rid of all possible
> rounding errors but it's enough for the slider test to pass.

Thanks for the investigationd and workaround!  I've tested it and it
seems to work well.  I've pushed a slightly modified version to master
as commit 81643c4cf3e61f5a98b92a72a92c230f5e7ca905.

Thank you!

Closing.

Maxim